package cn.com.qmth.stmms.biz.user.dao;

import cn.com.qmth.stmms.biz.user.model.OpenAccount;
import cn.com.qmth.stmms.biz.user.model.User;
import cn.com.qmth.stmms.common.enums.Role;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;
import java.util.Set;

public interface OpenAccountDao extends PagingAndSortingRepository<OpenAccount, Integer>, JpaSpecificationExecutor<OpenAccount> {

    List<OpenAccount> findBySchoolIdAndEnable(Integer schoolId, boolean enable);

    @Query("select o from OpenAccount o where o.schoolId=?1 and o.enable=?2 and not exists "
            + "(select m.id from Marker m where m.examId=?3 and m.subjectCode=?4 and m.groupNumber=?5 and m.openAccountId=o.id)")
    List<OpenAccount> findUnbind(Integer schoolId, boolean enable, Integer examId, String subjectCode, Integer groupNumber);

    OpenAccount findFirstBySchoolIdAndAccount(Integer schoolId, String account);

}
