package cn.com.qmth.stmms.biz.user.service;

import java.util.List;
import java.util.Set;

import cn.com.qmth.stmms.biz.user.model.OpenAccount;
import cn.com.qmth.stmms.biz.user.model.User;
import cn.com.qmth.stmms.biz.user.service.query.UserSearchQuery;
import cn.com.qmth.stmms.common.enums.Role;

public interface UserService {

    OpenAccount findOpenAccount(Integer id);

    List<OpenAccount> listOpenAccount(Integer schoolId);

    List<OpenAccount> listUnbindOpenAccount(Integer schoolId, Integer examId, String subjectCode, Integer groupNumber);

    OpenAccount openAccountLogin(Integer schoolId, String account);

    OpenAccount saveOpenAccount(Integer schoolId, String account, String name, boolean enable);

    User login(String loginName, String password, String ip);

    User findByLoginName(String loginName);

    List<User> findByLoginNameAndPassword(String loginName, String password);

    User findById(Integer id);

    List<User> findBySchoolIdAndRole(int schoolId, Role role);

    List<User> findBySchoolIdAndRoleSet(int schoolId, Set<Role> roleSet);

    UserSearchQuery findByQuery(final UserSearchQuery query);

    User save(User user);

    void deleteById(int id);

    void delete(User user);

    User findSchoolAdmin(int schoolId);

    User findSchoolViewer(Integer schoolId);

}
