package cn.com.qmth.stmms.common.domain;

import cn.com.qmth.stmms.biz.exam.model.Marker;
import cn.com.qmth.stmms.biz.user.model.OpenAccount;
import cn.com.qmth.stmms.biz.user.model.User;
import cn.com.qmth.stmms.common.enums.Role;

/**
 * 第三方账号访问用户抽象描述类
 *
 * @author luoshi
 */
public class OpenUser {

    private Integer id;

    private String name;

    private Role role;

    private String returnUrl;

    private String token;

    private OpenAccount userData;

    private OpenUser(Integer id, String name, Role role, String token, String returnUrl, OpenAccount userData) {
        this.id = id;
        this.name = name;
        this.role = role;
        this.token = token;
        this.returnUrl = returnUrl;
        this.userData = userData;
    }

    public OpenUser(OpenAccount account, String returnUrl) {
        this(account.getId(), account.getName(), Role.OPEN_ACCOUNT, account.getAccessToken(), returnUrl, account);
    }

    public OpenAccount getOpenAccount() {
        return userData;
    }

    public Integer getId() {
        return id;
    }

    public String getName() {
        return name;
    }

    public Role getRole() {
        return role;
    }

    public String getToken() {
        return token;
    }

    public String getReturnUrl() {
        return returnUrl;
    }
}
